import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React from "react";
import hoistNonReactStatics from "hoist-non-react-statics";
import { getDisplayName, propOr, path, isEmpty, diff } from "./utils";
import { StoreManager } from "./context";

var getStateProps = function getStateProps(_ref) {
  var selectors = _ref.selectors,
      instanceId = _ref.instanceId,
      cache = _ref.cache,
      state = _ref.state,
      props = _ref.props;
  return Object.entries(selectors || {}).reduce(function (acc, _ref2) {
    var _ref3 = _slicedToArray(_ref2, 2),
        key = _ref3[0],
        f = _ref3[1];

    if (f.id) {
      cache[f.id] = cache[f.id] || {};
    }

    return _objectSpread({}, acc, _defineProperty({}, key, f(state, _objectSpread({}, props || {}, {
      instanceId: instanceId
    }), cache)));
  }, {});
};

export var connect = function connect(selectors, actions) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  return function (Component) {
    var forwardRef = options.forwardRef;

    var ConnectComponent =
    /*#__PURE__*/
    function (_React$PureComponent) {
      _inherits(ConnectComponent, _React$PureComponent);

      function ConnectComponent(props, context) {
        var _this;

        _classCallCheck(this, ConnectComponent);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(ConnectComponent).call(this, props, context));
        var store = path(["moduleInstances", context.contextId, "store"], context);
        var instanceId = propOr(context.instanceId, "instanceId", props);
        var cache = {};
        _this.state = {
          cache: cache,
          store: store,
          stateProps: {},
          context: _objectSpread({}, context, {
            instanceId: instanceId,
            renderLevel: context.renderLevel + 1
          })
        };
        _this.subscription = store.subscribe(function () {
          _this.recomputeStateProps();
        }, context.renderLevel);
        return _this;
      }

      _createClass(ConnectComponent, [{
        key: "recomputeStateProps",
        value: function recomputeStateProps() {
          var newState = ConnectComponent.getDerivedStateFromProps(this.props, this.state);

          if (newState) {
            this.setState(newState);
          }
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          this.subscription();
        }
      }, {
        key: "render",
        value: function render() {
          var _this$state = this.state,
              stateProps = _this$state.stateProps,
              actionProps = _this$state.actionProps,
              context = _this$state.context;

          var _this$props = this.props,
              children = _this$props.children,
              props = _objectWithoutProperties(_this$props, ["children"]);

          return (
            /*#__PURE__*/
            React.createElement(StoreManager.Provider, {
              value: context
            },
            /*#__PURE__*/
            React.createElement(Component, _extends({
              instanceId: context.instanceId
            }, props, stateProps, actionProps), children))
          );
        }
      }], [{
        key: "getDerivedStateFromProps",
        value: function getDerivedStateFromProps(withChildren, state) {
          // eslint-disable-next-line no-unused-vars
          var children = withChildren.children,
              props = _objectWithoutProperties(withChildren, ["children"]);

          var newState = {};
          var instanceId = propOr(state.context.instanceId, "instanceId", props);
          var newStateProps = getStateProps({
            selectors: selectors,
            instanceId: instanceId,
            cache: state.cache,
            state: state.store.getState(),
            props: props
          });

          if (diff(state.stateProps, newStateProps)) {
            newState.stateProps = newStateProps;
          }

          if (!state.actionProps || instanceId !== state.context.instanceId) {
            newState.actionProps = ConnectComponent.computeActionProps(props, state);
            newState.context = _objectSpread({}, state.context, {
              instanceId: instanceId
            });
          }

          if (isEmpty(newState)) {
            return null;
          }

          return newState;
        }
      }, {
        key: "computeActionProps",
        value: function computeActionProps(props, state) {
          var instanceId = propOr(state.context.instanceId, "instanceId", props);
          return Object.entries(actions || {}).reduce(function (actions, _ref4) {
            var _ref5 = _slicedToArray(_ref4, 2),
                key = _ref5[0],
                f = _ref5[1];

            if (typeof f !== "function") {
              throw Error("".concat(key, " is not a function"));
            }

            actions[key] = function (payload) {
              var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
              var error = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
              return state.store.dispatch(f(payload, _objectSpread({}, props, {
                meta: _objectSpread({
                  instanceId: instanceId
                }, props.meta || {})
              }), error));
            };

            return actions;
          }, {});
        }
      }]);

      return ConnectComponent;
    }(React.PureComponent);

    ConnectComponent.contextType = StoreManager;
    ConnectComponent.displayName = "MVCInyectProps(".concat(getDisplayName(Component), ")");
    var Connect = React.memo(ConnectComponent);

    if (forwardRef) {
      Connect = React.forwardRef(function (props, ref) {
        return (
          /*#__PURE__*/
          React.createElement(ConnectComponent, _extends({}, props, {
            reduxMVCForwardedRef: ref
          }))
        );
      });
    }

    Connect.displayName = "MVCConnect(".concat(getDisplayName(Component), ")");
    return hoistNonReactStatics(Connect, Component);
  };
};