import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import { DEFAULT_INSTANCE_ID } from "./constants";
import { prop, propOr, pathOr, mergeAll, getSelectorInstanceId, capitalizeFirst, identity } from "./utils";
export var createModel = function createModel(_ref) {
  var _ref$iniState = _ref.iniState,
      iniState = _ref$iniState === void 0 ? {} : _ref$iniState,
      _ref$reducers = _ref.reducers,
      reducers = _ref$reducers === void 0 ? {} : _ref$reducers,
      _ref$namespace = _ref.namespace,
      _namespace = _ref$namespace === void 0 ? "" : _ref$namespace,
      _ref$singleton = _ref.singleton,
      singleton = _ref$singleton === void 0 ? false : _ref$singleton,
      props = _objectWithoutProperties(_ref, ["iniState", "reducers", "namespace", "singleton"]);

  var setActions = Object.keys(iniState).reduce(function (acc, key) {
    var setKey = "set".concat(capitalizeFirst(key));
    var type = "".concat(_namespace + "/").concat(setKey);

    var action = function action(payload) {
      var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var error = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      return _objectSpread({
        payload: payload
      }, props, {
        error: error,
        type: type,
        namespace: _namespace
      });
    };

    action.type = type;
    action.key = key;
    return _objectSpread({}, acc, _defineProperty({}, setKey, action));
  }, {});
  var customActions = Object.keys(reducers).reduce(function (acc, key) {
    var type = "".concat(_namespace + "/").concat(key);

    var action = function action(payload) {
      var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var error = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      return _objectSpread({}, props, {
        payload: payload,
        error: error,
        type: type,
        namespace: _namespace
      });
    };

    action.type = type;
    action.key = key;
    return _objectSpread({}, acc, _defineProperty({}, key, action));
  }, {});
  var setReducers = Object.values(setActions).reduce(function (acc, action) {
    return _objectSpread({}, acc, _defineProperty({}, action.type, function (state, _ref2) {
      var payload = _ref2.payload;
      return _defineProperty({}, action.key, payload);
    }));
  }, {});
  var customReducers = Object.values(customActions).reduce(function (acc, action) {
    return _objectSpread({}, acc, _defineProperty({}, action.type, reducers[action.key]));
  }, {});
  var actions = mergeAll([setActions, customActions]);
  var getters = Object.keys(iniState).reduce(function (acc, key) {
    return _objectSpread({}, acc, _defineProperty({}, key, function (state) {
      var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var instanceId = getSelectorInstanceId(props, singleton);
      return pathOr(prop(key, iniState), [_namespace, instanceId, key], state);
    }));
  }, {
    instance: function instance(state, props) {
      var instanceId = getSelectorInstanceId(props, singleton);
      return pathOr(iniState, [_namespace, instanceId], state);
    },
    namespace: function namespace(state) {
      return propOr(iniState, _namespace, state);
    },
    module: identity
  });
  var handlers = mergeAll([setReducers, customReducers]); // reducers

  return _objectSpread({
    namespace: _namespace,
    iniState: _defineProperty({}, _namespace, _defineProperty({}, DEFAULT_INSTANCE_ID, iniState)),
    reducers: handlers,
    actions: actions,
    getters: getters,
    singleton: singleton
  }, props);
};