import _extends from "@babel/runtime/helpers/esm/extends";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import React, { PureComponent } from "react";
import { getDisplayName } from "./utils";
import { StoreManager } from "./context";
import { DEFAULT_INSTANCE_ID } from "./constants";
export var createContext = function createContext(_ref) {
  var module = _ref.module,
      _ref$contextId = _ref.contextId,
      contextId = _ref$contextId === void 0 ? Symbol("MVCContextId") : _ref$contextId,
      options = _objectWithoutProperties(_ref, ["module", "contextId"]);

  return function (WrappedComponent) {
    var WithReduxMVCContext =
    /*#__PURE__*/
    function (_PureComponent) {
      _inherits(WithReduxMVCContext, _PureComponent);

      function WithReduxMVCContext(props, context) {
        var _this;

        _classCallCheck(this, WithReduxMVCContext);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(WithReduxMVCContext).call(this, props, context));
        context.moduleInstances[contextId] = context.moduleInstances[contextId] || _objectSpread({}, module);

        _this.callLifeCycle("constructor");

        return _this;
      }

      _createClass(WithReduxMVCContext, [{
        key: "updateModuleInstance",
        value: function updateModuleInstance(moduleInstance) {
          if (moduleInstance) {
            this.context.moduleInstances[contextId] = moduleInstance;
            this.store = moduleInstance.store;
          }
        }
      }, {
        key: "lifeCycleExists",
        value: function lifeCycleExists(name, module) {
          return typeof module[name] === "function";
        }
      }, {
        key: "callLifeCycle",
        value: function callLifeCycle(name) {
          var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

          if (this.lifeCycleExists(name, module)) {
            this.updateModuleInstance(module[name].call(this, _objectSpread({
              moduleInstances: this.context.moduleInstances,
              contextId: contextId
            }, options, {}, params)));
          }
        }
      }, {
        key: "componentDidCatch",
        value: function componentDidCatch(error, info) {
          this.callLifeCycle("componentDidCatch", {
            error: error,
            info: info
          });
        }
      }, {
        key: "componentDidMount",
        value: function componentDidMount() {
          this.callLifeCycle("componentDidMount");
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          this.callLifeCycle("componentWillUnmount");
        }
      }, {
        key: "render",
        value: function render() {
          var instanceId = this.props.instanceId || DEFAULT_INSTANCE_ID;
          return (
            /*#__PURE__*/
            React.createElement(StoreManager.Provider, {
              value: _objectSpread({}, this.context, {
                contextId: contextId,
                instanceId: instanceId,
                renderLevel: 0
              })
            },
            /*#__PURE__*/
            React.createElement(WrappedComponent, _extends({}, this.props, {
              instanceId: instanceId
            })))
          );
        }
      }]);

      return WithReduxMVCContext;
    }(PureComponent);

    WithReduxMVCContext.contextType = StoreManager;
    WithReduxMVCContext.displayName = "MVCContext(".concat(getDisplayName(WrappedComponent), ")");
    return WithReduxMVCContext;
  };
};