import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import { pathOr } from "./utils";
import { EMPTY, DEFAULT_INSTANCE_ID } from "./constants";
export var createSelector = function createSelector() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  if (args.length === 1) {
    return args[0];
  }

  var id = Symbol("selectorId");
  var dependencies = args.slice(0, -1);
  var resultFn = args[args.length - 1];

  var ownCache = _defineProperty({}, id, {});

  var selector = function selector(state) {
    var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var cache = arguments.length > 2 ? arguments[2] : undefined;
    var instanceId = props.instanceId || DEFAULT_INSTANCE_ID;
    var selectedCache = cache || ownCache;
    var newDeps = dependencies.map(function (dep) {
      return dep(state, props, selectedCache);
    });
    var lastValue = pathOr(EMPTY, [id, instanceId, "lastValue"], selectedCache);

    if (lastValue !== EMPTY) {
      var lastDeps = pathOr([], [id, instanceId, "deps"], selectedCache);

      if (newDeps.every(function (val, i) {
        return val === lastDeps[i];
      })) {
        return lastValue;
      }
    }

    var newValue = resultFn.apply(void 0, _toConsumableArray(newDeps));
    selectedCache[id] = _objectSpread({}, selectedCache[id] || {}, _defineProperty({}, instanceId, {
      deps: newDeps,
      lastValue: newValue
    }));
    return newValue;
  };

  selector.id = id;
  selector.dependencies = dependencies;
  selector.resultFn = resultFn;
  selector.ownCache = ownCache;
  return selector;
};