"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.connect = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectSpread3 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireDefault(require("react"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _utils = require("./utils");

var _context = require("./context");

var getStateProps = function getStateProps(_ref) {
  var selectors = _ref.selectors,
      instanceId = _ref.instanceId,
      cache = _ref.cache,
      state = _ref.state,
      props = _ref.props;
  return Object.entries(selectors || {}).reduce(function (acc, _ref2) {
    var _ref3 = (0, _slicedToArray2["default"])(_ref2, 2),
        key = _ref3[0],
        f = _ref3[1];

    if (f.id) {
      cache[f.id] = cache[f.id] || {};
    }

    return (0, _objectSpread3["default"])({}, acc, (0, _defineProperty2["default"])({}, key, f(state, (0, _objectSpread3["default"])({}, props || {}, {
      instanceId: instanceId
    }), cache)));
  }, {});
};

var connect = function connect(selectors, actions) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  return function (Component) {
    var forwardRef = options.forwardRef;

    var ConnectComponent =
    /*#__PURE__*/
    function (_React$PureComponent) {
      (0, _inherits2["default"])(ConnectComponent, _React$PureComponent);

      function ConnectComponent(props, context) {
        var _this;

        (0, _classCallCheck2["default"])(this, ConnectComponent);
        _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(ConnectComponent).call(this, props, context));
        var store = (0, _utils.path)(["moduleInstances", context.contextId, "store"], context);
        var instanceId = (0, _utils.propOr)(context.instanceId, "instanceId", props);
        var cache = {};
        _this.state = {
          cache: cache,
          store: store,
          stateProps: {},
          context: (0, _objectSpread3["default"])({}, context, {
            instanceId: instanceId,
            renderLevel: context.renderLevel + 1
          })
        };
        _this.subscription = store.subscribe(function () {
          _this.recomputeStateProps();
        }, context.renderLevel);
        return _this;
      }

      (0, _createClass2["default"])(ConnectComponent, [{
        key: "recomputeStateProps",
        value: function recomputeStateProps() {
          var newState = ConnectComponent.getDerivedStateFromProps(this.props, this.state);

          if (newState) {
            this.setState(newState);
          }
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          this.subscription();
        }
      }, {
        key: "render",
        value: function render() {
          var _this$state = this.state,
              stateProps = _this$state.stateProps,
              actionProps = _this$state.actionProps,
              context = _this$state.context;
          var _this$props = this.props,
              children = _this$props.children,
              props = (0, _objectWithoutProperties2["default"])(_this$props, ["children"]);
          return (
            /*#__PURE__*/
            _react["default"].createElement(_context.StoreManager.Provider, {
              value: context
            },
            /*#__PURE__*/
            _react["default"].createElement(Component, (0, _extends2["default"])({
              instanceId: context.instanceId
            }, props, stateProps, actionProps), children))
          );
        }
      }], [{
        key: "getDerivedStateFromProps",
        value: function getDerivedStateFromProps(withChildren, state) {
          // eslint-disable-next-line no-unused-vars
          var children = withChildren.children,
              props = (0, _objectWithoutProperties2["default"])(withChildren, ["children"]);
          var newState = {};
          var instanceId = (0, _utils.propOr)(state.context.instanceId, "instanceId", props);
          var newStateProps = getStateProps({
            selectors: selectors,
            instanceId: instanceId,
            cache: state.cache,
            state: state.store.getState(),
            props: props
          });

          if ((0, _utils.diff)(state.stateProps, newStateProps)) {
            newState.stateProps = newStateProps;
          }

          if (!state.actionProps || instanceId !== state.context.instanceId) {
            newState.actionProps = ConnectComponent.computeActionProps(props, state);
            newState.context = (0, _objectSpread3["default"])({}, state.context, {
              instanceId: instanceId
            });
          }

          if ((0, _utils.isEmpty)(newState)) {
            return null;
          }

          return newState;
        }
      }, {
        key: "computeActionProps",
        value: function computeActionProps(props, state) {
          var instanceId = (0, _utils.propOr)(state.context.instanceId, "instanceId", props);
          return Object.entries(actions || {}).reduce(function (actions, _ref4) {
            var _ref5 = (0, _slicedToArray2["default"])(_ref4, 2),
                key = _ref5[0],
                f = _ref5[1];

            if (typeof f !== "function") {
              throw Error("".concat(key, " is not a function"));
            }

            actions[key] = function (payload) {
              var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
              var error = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
              return state.store.dispatch(f(payload, (0, _objectSpread3["default"])({}, props, {
                meta: (0, _objectSpread3["default"])({
                  instanceId: instanceId
                }, props.meta || {})
              }), error));
            };

            return actions;
          }, {});
        }
      }]);
      return ConnectComponent;
    }(_react["default"].PureComponent);

    ConnectComponent.contextType = _context.StoreManager;
    ConnectComponent.displayName = "MVCInyectProps(".concat((0, _utils.getDisplayName)(Component), ")");

    var Connect = _react["default"].memo(ConnectComponent);

    if (forwardRef) {
      Connect = _react["default"].forwardRef(function (props, ref) {
        return (
          /*#__PURE__*/
          _react["default"].createElement(ConnectComponent, (0, _extends2["default"])({}, props, {
            reduxMVCForwardedRef: ref
          }))
        );
      });
    }

    Connect.displayName = "MVCConnect(".concat((0, _utils.getDisplayName)(Component), ")");
    return (0, _hoistNonReactStatics["default"])(Connect, Component);
  };
};

exports.connect = connect;