"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createModel = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectSpread7 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _constants = require("./constants");

var _utils = require("./utils");

var createModel = function createModel(_ref) {
  var _ref$iniState = _ref.iniState,
      iniState = _ref$iniState === void 0 ? {} : _ref$iniState,
      _ref$reducers = _ref.reducers,
      reducers = _ref$reducers === void 0 ? {} : _ref$reducers,
      _ref$namespace = _ref.namespace,
      _namespace = _ref$namespace === void 0 ? "" : _ref$namespace,
      _ref$singleton = _ref.singleton,
      singleton = _ref$singleton === void 0 ? false : _ref$singleton,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["iniState", "reducers", "namespace", "singleton"]);

  var setActions = Object.keys(iniState).reduce(function (acc, key) {
    var setKey = "set".concat((0, _utils.capitalizeFirst)(key));
    var type = "".concat(_namespace + "/").concat(setKey);

    var action = function action(payload) {
      var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var error = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      return (0, _objectSpread7["default"])({
        payload: payload
      }, props, {
        error: error,
        type: type,
        namespace: _namespace
      });
    };

    action.type = type;
    action.key = key;
    return (0, _objectSpread7["default"])({}, acc, (0, _defineProperty2["default"])({}, setKey, action));
  }, {});
  var customActions = Object.keys(reducers).reduce(function (acc, key) {
    var type = "".concat(_namespace + "/").concat(key);

    var action = function action(payload) {
      var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var error = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      return (0, _objectSpread7["default"])({}, props, {
        payload: payload,
        error: error,
        type: type,
        namespace: _namespace
      });
    };

    action.type = type;
    action.key = key;
    return (0, _objectSpread7["default"])({}, acc, (0, _defineProperty2["default"])({}, key, action));
  }, {});
  var setReducers = Object.values(setActions).reduce(function (acc, action) {
    return (0, _objectSpread7["default"])({}, acc, (0, _defineProperty2["default"])({}, action.type, function (state, _ref2) {
      var payload = _ref2.payload;
      return (0, _defineProperty2["default"])({}, action.key, payload);
    }));
  }, {});
  var customReducers = Object.values(customActions).reduce(function (acc, action) {
    return (0, _objectSpread7["default"])({}, acc, (0, _defineProperty2["default"])({}, action.type, reducers[action.key]));
  }, {});
  var actions = (0, _utils.mergeAll)([setActions, customActions]);
  var getters = Object.keys(iniState).reduce(function (acc, key) {
    return (0, _objectSpread7["default"])({}, acc, (0, _defineProperty2["default"])({}, key, function (state) {
      var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var instanceId = (0, _utils.getSelectorInstanceId)(props, singleton);
      return (0, _utils.pathOr)((0, _utils.prop)(key, iniState), [_namespace, instanceId, key], state);
    }));
  }, {
    instance: function instance(state, props) {
      var instanceId = (0, _utils.getSelectorInstanceId)(props, singleton);
      return (0, _utils.pathOr)(iniState, [_namespace, instanceId], state);
    },
    namespace: function namespace(state) {
      return (0, _utils.propOr)(iniState, _namespace, state);
    },
    module: _utils.identity
  });
  var handlers = (0, _utils.mergeAll)([setReducers, customReducers]); // reducers

  return (0, _objectSpread7["default"])({
    namespace: _namespace,
    iniState: (0, _defineProperty2["default"])({}, _namespace, (0, _defineProperty2["default"])({}, _constants.DEFAULT_INSTANCE_ID, iniState)),
    reducers: handlers,
    actions: actions,
    getters: getters,
    singleton: singleton
  }, props);
};

exports.createModel = createModel;