"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createSelector = void 0;

var _objectSpread3 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _utils = require("./utils");

var _constants = require("./constants");

var createSelector = function createSelector() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  if (args.length === 1) {
    return args[0];
  }

  var id = Symbol("selectorId");
  var dependencies = args.slice(0, -1);
  var resultFn = args[args.length - 1];
  var ownCache = (0, _defineProperty2["default"])({}, id, {});

  var selector = function selector(state) {
    var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var cache = arguments.length > 2 ? arguments[2] : undefined;
    var instanceId = props.instanceId || _constants.DEFAULT_INSTANCE_ID;
    var selectedCache = cache || ownCache;
    var newDeps = dependencies.map(function (dep) {
      return dep(state, props, selectedCache);
    });
    var lastValue = (0, _utils.pathOr)(_constants.EMPTY, [id, instanceId, "lastValue"], selectedCache);

    if (lastValue !== _constants.EMPTY) {
      var lastDeps = (0, _utils.pathOr)([], [id, instanceId, "deps"], selectedCache);

      if (newDeps.every(function (val, i) {
        return val === lastDeps[i];
      })) {
        return lastValue;
      }
    }

    var newValue = resultFn.apply(void 0, (0, _toConsumableArray2["default"])(newDeps));
    selectedCache[id] = (0, _objectSpread3["default"])({}, selectedCache[id] || {}, (0, _defineProperty2["default"])({}, instanceId, {
      deps: newDeps,
      lastValue: newValue
    }));
    return newValue;
  };

  selector.id = id;
  selector.dependencies = dependencies;
  selector.resultFn = resultFn;
  selector.ownCache = ownCache;
  return selector;
};

exports.createSelector = createSelector;